<script lang="ts">
import Vue from 'vue';
import VueSlickCarousel from 'vue-slick-carousel';
import ChevronLg from '../../static/nuxt-images/ico/chevron-lg.vue';
import SlpContainer from '../common/container.vue';
import SlpRow from '../common/row.vue';
import SlpColumn from '../common/column.vue';

export default Vue.extend({
  name: 'TierBlock',
  components: { SlpColumn, SlpRow, SlpContainer, ChevronLg, VueSlickCarousel },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      isMobile: false,
      activeCarouselIndex: 1,
      width: 0,
    };
  },
  mounted() {
    this.onResize();
    window.addEventListener('resize', this.onResize);
  },
  destroyed() {
    window.removeEventListener('resize', this.onResize);
  },
  methods: {
    onResize() {
      this.isMobile = window.innerWidth < 768;
      this.width = window.innerWidth;
    },
    moveCarousel(index: number): void {
      const { tierCarousel } = this.$refs;
      this.activeCarouselIndex = index;
      if (tierCarousel.goTo) {
        tierCarousel.goTo(index);
      }
    },
    handleCarouselChange(index: number) {
      this.activeCarouselIndex = index;
    },
  },
});
</script>

<template>
  <section class="tiers-block slp-mb-md-96 slp-mb-48">
    <SlpContainer>
      <div class="tiers-block__header">
        <SlpTypography
          class="tiers-block__header-text"
          tag="h1"
          variant="heading1-bold"
        >
          {{ data.header }}
        </SlpTypography>
      </div>
      <div v-if="isMobile" class="tiers-block__carousel_buttons">
        <button
          class="free"
          :class="{ active: activeCarouselIndex === 0 }"
          @click="moveCarousel(0)"
        >
          <SlpTypography variant="body1-bold"> Free</SlpTypography>
        </button>
        <button
          class="premium"
          :class="{ active: activeCarouselIndex === 1 }"
          @click="moveCarousel(1)"
        >
          <SlpTypography variant="body1-bold"> Premium</SlpTypography>
        </button>
        <button
          class="ultimate"
          :class="{ active: activeCarouselIndex === 2 }"
          @click="moveCarousel(2)"
        >
          <SlpTypography variant="body1-bold"> Ultimate</SlpTypography>
        </button>
      </div>
      <div>
        <component
          :is="isMobile ? 'VueSlickCarousel' : 'slp-row'"
          ref="tierCarousel"
          center-mode
          :center-padding="`${width / 50}%`"
          :infinite="false"
          :dots="true"
          class="tiers-block__tiers"
          :initial-slide="1"
          @afterChange="handleCarouselChange"
        >
          <SlpColumn
            v-for="tier in data.tiers"
            :key="tier.title"
            :cols="4"
            class="slp-flex"
          >
            <div
              class="tiers-block__tier"
              :class="[`tiers-block__tier--${tier.id}`]"
            >
              <SlpTypography tag="h3" variant="heading3-bold" class="slp-mb-16">
                {{ tier.title }}
              </SlpTypography>
              <ul>
                <li
                  v-for="item in tier.items"
                  :key="item"
                  class="tiers-block__tier-item"
                >
                  <img
                    class="slp-mr-16"
                    src="/nuxt-images/icons/slp-success-checkmark.svg"
                    alt=""
                    aria-hidden="true"
                  />
                  <SlpTypography tag="span" variant="body1"
                    >{{ item }}
                  </SlpTypography>
                </li>
              </ul>
              <SlpButton
                variant="tertiary"
                class="tiers-block__tier-link"
                :href="tier.link.href"
                :data-ga-name="tier.link.data_ga_name"
                :data-ga-location="tier.link.data_ga_location"
                :aria-label="tier.link.aria_label"
              >
                {{ tier.link.text }}
                <ChevronLg
                  aria-hidden="true"
                  class="slp-ml-8"
                  direction="right"
                />
              </SlpButton>
            </div>
          </SlpColumn>
        </component>
      </div>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.tiers-block {
  &__header {
    display: flex;
    justify-content: space-between;
    align-items: flex-end;
    margin-bottom: $spacing-32;
  }

  &__header-text {
    @media (min-width: $breakpoint-lg) {
      max-width: 40%;
    }
  }

  &__tiers {
    display: flex;
    height: auto;

    &::v-deep {
      div {
        @media (max-width: $breakpoint-md) {
          height: 100%;
        }
      }

      .slick-track {
        display: flex !important;
      }

      .slick-slide {
        height: auto;
      }
    }
  }

  &__tier {
    padding: $spacing-24;
    margin: 0 $spacing-8;
    border-radius: 4px;
    height: 100%;

    @media (min-width: $breakpoint-md) {
      margin: 0 $spacing-16;
      padding: $spacing-32;
    }

    &--free {
      background-color: $color-surface-100;
    }

    &--premium {
      background-color: $color-surface-900;
    }

    &--ultimate {
      border-radius: 4px 4px 100px 4px;
      background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
      border: 1px solid $color-surface-900;
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center center;
    }
  }

  &__tier-item {
    margin-bottom: $spacing-16;
    display: flex;
    align-items: baseline;
  }

  &__tier-link {
    &:hover {
      background-color: inherit !important;
    }
  }

  &__carousel_buttons {
    display: flex;
    width: 100%;
    justify-content: space-around;
    height: 42px;
    margin: $spacing-32 0;

    button {
      border: none;
      width: 100%;
      border-bottom: 1px solid transparent;
      opacity: 0.2;
      color: $color-primary-200;
      transition: all 0.3s ease-in-out;

      &.active {
        border-bottom: 1px solid #171321;
        opacity: 1;
      }
    }
  }
}
</style>
